/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ca.mcscert.jtet.tablularexpression;

import java.util.ArrayList;
import java.util.List;
import java.util.Stack;

/**
 *
 * @author Matthew Dawson <matthew@mjdsystems.ca>
 */
public class HierarchicalGrid implements SubHierarchyFetcher {
    @Override
    public List<HierarchicalCell> getSubHierarchy() {
        return m_subHierarchy;
    }

    /** This counts the number of different cases this grid represents
     *
     * countTotalCases counts the total number of outputs this grid requires
     * to satisfy its total number of cases.
     *
     * @return The number of distinct cases.
     */
    public int countTotalCases() {
        int count = 0;

        Stack<HierarchicalCell> toCheck = new Stack<HierarchicalCell>();
        toCheck.addAll(m_subHierarchy);
        while (!toCheck.empty()) {
            HierarchicalCell next = toCheck.pop();
            List<HierarchicalCell> subGrid = next.getSubHierarchy();
            if (subGrid.isEmpty()) {
                count++;
            } else {
                toCheck.addAll(subGrid);
            }
        }
        return count;
    }
    
    private List<HierarchicalCell> m_subHierarchy = new ArrayList<HierarchicalCell>();
}
